=== debian/changelog ===
julia (1.4.1+dfsg-1) unstable; urgency=medium

  * New upstream release
  * Refresh patches
  * Update libjulia1.symbols

 -- Graham Inggs <ginggs@debian.org>  Tue, 21 Apr 2020 11:21:34 +0000

julia (1.4.0+dfsg-2) unstable; urgency=medium

  * Do not run dwz on sys.so, it fails on i386

 -- Graham Inggs <ginggs@debian.org>  Sat, 18 Apr 2020 17:50:16 +0000

julia (1.4.0+dfsg-1) unstable; urgency=medium

  [ Mo Zhou ]
  * New upstream version 1.4.0+dfsg

  [ Graham Inggs ]
  * Add build-dependency on python3-minimal
  * Only link libquadmath on architectures where it is available
  * Drop unused debian/source/include-binaries
  * Drop unused Lintian overrides
  * Add Build-Depends-Package to libjulia1.symbols
  * Switch to debhelper 12
  * Set Rules-Requires-Root: no
  * Bump Standards-Version to 4.5.0, no changes

 -- Graham Inggs <ginggs@debian.org>  Fri, 17 Apr 2020 08:17:56 +0000
